Subject: Re: [PATCH v6 01/17] mm/slab: Decouple ARCH_KMALLOC_MINALIGN from ARCH_DMA_MINALIGN

From: Catalin Marinas <[email-masked]>
Date: Fri, 9 Jun 2023 14:44:01 +0100

On Fri, Jun 09, 2023 at 02:32:57PM +0200, Vlastimil Babka wrote:
> On 5/31/23 17:48, Catalin Marinas wrote:
> > diff --git a/include/linux/dma-mapping.h b/include/linux/dma-mapping.h
> > index 0ee20b764000..3288a1339271 100644
> > --- a/include/linux/dma-mapping.h
> > +++ b/include/linux/dma-mapping.h
> > @@ -545,7 +545,7 @@ static inline int dma_set_min_align_mask(struct device *dev,
> >  
> >  static inline int dma_get_cache_alignment(void)
> >  {
> > -#ifdef ARCH_DMA_MINALIGN
> > +#ifdef ARCH_HAS_DMA_MINALIGN
> >  	return ARCH_DMA_MINALIGN;
> >  #endif
> >  	return 1;
> > diff --git a/include/linux/slab.h b/include/linux/slab.h
> > index 6b3e155b70bf..50dcf9cfbf62 100644
> > --- a/include/linux/slab.h
> > +++ b/include/linux/slab.h
> > @@ -235,12 +235,20 @@ void kmem_dump_obj(void *object);
> >   * alignment larger than the alignment of a 64-bit integer.
> >   * Setting ARCH_DMA_MINALIGN in arch headers allows that.
> >   */
> > -#if defined(ARCH_DMA_MINALIGN) && ARCH_DMA_MINALIGN > 8
> > +#ifdef ARCH_DMA_MINALIGN
> > +#define ARCH_HAS_DMA_MINALIGN
> > +#if ARCH_DMA_MINALIGN > 8 && !defined(ARCH_KMALLOC_MINALIGN)
> >  #define ARCH_KMALLOC_MINALIGN ARCH_DMA_MINALIGN
> > -#define KMALLOC_MIN_SIZE ARCH_DMA_MINALIGN
> > -#define KMALLOC_SHIFT_LOW ilog2(ARCH_DMA_MINALIGN)
> > +#endif
> >  #else
> > +#define ARCH_DMA_MINALIGN __alignof__(unsigned long long)
> > +#endif
> 
> It seems weird to make slab.h responsible for this part, especially for
> #define ARCH_HAS_DMA_MINALIGN, which dma-mapping.h consumes. Maybe it would
> be difficult to do differently due to some dependency hell, but minimally I
> don't see dma-mapping.h including slab.h so the result is
> include-order-dependent? Maybe it's included transitively, but then it's
> fragile and would be better to do explicitly?

True, there's a risk that it doesn't get included with some future
header refactoring.

What about moving ARCH_DMA_MINALIGN to linux/cache.h? Alternatively, I
could create a new linux/dma-minalign.h file but I feel since this is
about caches, having it in cache.h makes more sense. asm/cache.h is also
where most archs define the constant (apart from mips, sh, microblaze).

-- 
Catalin

_______________________________________________
linux-arm-kernel mailing list
[email-masked]
http://lists.infradead.org/mailman/listinfo/linux-arm-kernel